---
import yaml from 'js-yaml';
import fs from 'fs';

import * as Icon from '@astropub/icons'


// this class creates black borders around multiple elements for better development experience
export let blackBorderClass = ``;
// export let blackBorderClass = `border border-black sm:border sm:border-black`;

// Read the YAML file
const commonContents = fs.readFileSync(new URL('./data/common/vars.yaml', import.meta.url), 'utf8');
// Parse the YAML to get a JavaScript object
const commonVars = yaml.load(commonContents);

const headerClassesContents = fs.readFileSync(new URL('./data/header/style.yaml', import.meta.url), 'utf8');
const headerClasses = yaml.load(headerClassesContents);

const dropdownsContents = fs.readFileSync(new URL('./data/header/dropdowns.yaml', import.meta.url), 'utf8');
const dropdowns = yaml.load(dropdownsContents);

const profileButtonContents = fs.readFileSync(new URL('./data/header/profile.yaml', import.meta.url), 'utf8');
const profileButton = yaml.load(profileButtonContents);

const linkButtonsContents = fs.readFileSync(new URL('./data/header/link_buttons.yaml', import.meta.url), 'utf8');
const linkButtons = yaml.load(linkButtonsContents);

const breadcrumbsContents = fs.readFileSync(new URL('./data/header/breadcrumbs.yaml', import.meta.url), 'utf8');
const breadcrumbs = yaml.load(breadcrumbsContents);

// Function to check if a key exists in the user object
function hasKey(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
}


---

<header class="w-screen bg-white mx-auto px-1">
    <!-- Top Part of the Header -->
    <div class="flex justify-between">
        <!-- Logo -->
        <a href={commonVars.HEADER_LOGO_LINK}>
            <img src={commonVars.HEADER_LOGO_SRC} alt={commonVars.HEADER_LOGO_ALT} 
                class={"object-contain h-16" + ' ' + blackBorderClass}/>
        </a>

        <!-- Top Buttons -->
        <div id="navbar-multi-level" class={"sm:block sm:w-auto" + ' ' + blackBorderClass}>
            <ul class="flex flex-col space-x-0
                        sm:flex-row sm:space-x-0">

                    <!-- Search Field -->
                    <li>
                        <form class="relative">
                                <input type="search" id="search" placeholder="Search" required class={headerClasses.searchFieldClass}/>
                                <button type="submit" class="absolute top-1 end-1">
                                    <Icon.MagnifyingGlass size="20"/>
                                </button>
                        </form>
                    </li>

            
                <!-- List of Dropdown Buttons -->
                {dropdowns.map((dropdown) => (
                    <li class="group">
                        <!-- Dropdown Button-->
                        <div id={dropdown.button_id} class={headerClasses.dropdownButtonClass + ' ' + dropdown.class}>
                            {dropdown.title}
                            <Icon.CaretDown size="20"/>
                        </div>
                        <!-- Dropdown menu Options -->
                        <div id={dropdown.menu_id} class={headerClasses.dropdownMenuClass}>
                            <ul>
                                {dropdown.options.map((option) => (
                                    <li>
                                        {(hasKey(option, 'href')) ?
                                            (
                                                <a href={option.href} class={headerClasses.dropdownMenuOptionClass}>
                                                    {(hasKey(option, 'icon')) && (<Icon[option.icon] size="20"/> )}
                                                    {option.title}
                                                </a>
                                            ) : 
                                            (
                                                <span class={headerClasses.dropdownMenuOptionClass + ' ' + "cursor-default"}>
                                                    {(hasKey(option, 'icon')) && (<Icon[option.icon] size="20"/> )}
                                                    {option.title}
                                                </span>
                                            )
                                        }
                                    </li>
                                ))}
                            
                            </ul>
                        </div>
                    </li>
                ))}
        
                    <!-- Profile Dropdown Button -->
                    <!-- <li>
                        {profileButton.map((item) => (
                            <img  id="profileButton" type="button" data-dropdown-toggle="profileDropdown"  
                                    data-dropdown-placement="bottom-start"  
                                    class={headerClasses.profileButtonClass} 
                                    src={item.image_src} 
                                    alt={item.title} />
                            <ul aria-labelledby="profileButton">
                                <div id="profileDropdown" class={headerClasses.dropdownMenuClass}>
                                    {item.options.map((item) => (
                                        <li>
                                            {(hasKey(item, 'href')) ?
                                                (
                                                    <a href={item.href} class={headerClasses.dropdownMenuOptionClass}>
                                                        {item.title}
                                                    </a>
                                                ) : 
                                                (
                                                    <span class={headerClasses.dropdownMenuOptionClass}>
                                                        {item.title}
                                                    </span>
                                                )
                                            }
                                        </li>
                                    ))}
                                </div>
                            </ul>
                        ))}
                    </li> -->
            </ul>
            
            <ul class={headerClasses.linkButtonClass + ' ' + blackBorderClass}>
                <!-- Buttons with links -->
                {linkButtons.map((linkButton) => (
                    <li class="px-2">
                        <a href={linkButton.href} class="text-sm font-semibold text-gray-900">{linkButton.title}</a>
                    </li>
                ))}
            </ul>

        </div>
    </div>
    <!-- Bottom Part of the Header -->
    <!-- Breadcrumb -->
    <nav class={"flex pl-1" + ' ' + blackBorderClass} aria-label="Breadcrumb">
        <ul class={headerClasses.breadcrumbClass}>
            {breadcrumbs.map((breadcrumb, index) => (
                <li class="inline-flex">
                    <a href={breadcrumb.href}>
                        {breadcrumb.title}
                    </a>
                    {(index != breadcrumbs.length - 1) && (
                        <Icon.CaretRight size="16"/>
                    )}
                </li>
            ))}
        </ul>
    </nav>


</header>
